/*
 *  GRUB  --  GRand Unified Bootloader
 *  Copyright (C) 1996   Erich Boleyn  <erich@uruk.org>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include "shared.h"

void
cmain(void)
{
#ifdef PC9800
  unsigned int size;
#endif

  printf(MSG2("\n\nGRUB loading, please wait...\n",
	      "\n\nGRUB ɤ߹ǤޤԤ...\n"));

  /*
   *  Here load the true second-stage boot-loader.
   */

#ifndef PC9800
  if (open(config_file) && read((void *)0x8000, -1))
    chain_stage2(0, 0x8000);
#else
  if (open(config_file)
      && read((void *)0x8000, STAGE2_SIZE_OFFS + 4) == STAGE2_SIZE_OFFS + 4
      && (size = (*(unsigned int *)(0x8000 + STAGE2_SIZE_OFFS)
		  - (STAGE2_SIZE_OFFS + 4)),
	  read((void *)(0x8000 + STAGE2_SIZE_OFFS + 4), size) == size))
    chain_stage2(0, 0x8000);
#endif

  /*
   *  If not, then print error message and die.
   */

#ifndef PC9800
  print_error();

  stop();
#else
  panic(MSG2("couldn't load %s! (error %d)", "%s ɤ߹ޤ (׎ %d)"),
	config_file, errnum);
#endif
}

